not used (too slow)

.globl  ppu_renderBGLinea
	.align 4	
@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
@@ppu_renderBGLinea
@@------------------
@@   input : r0 = drawing buffer  (8+256+8 bytes long)
@@           r1 = Vnes.PPUPageIndex
@@   output : none
@@   + Draw the sprites cached on previous line
@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@	

@@ REGISTERS Usage

@@ r12 = buf_ptr
@@ r11 = bg_offset
@@ r10 = refresh_vaddr
@@ r9 = y_tile/attrib_base
@@ r8 = x_tile
@@ r7 = attrib_shift
@@ r6 = VnesPPUPageIndex
@@ r5 = tilePtr
@@ r4 = attribPtr

ppu_renderBGLinea:
	stmfd	  r13!,{r4-r11}
				 	
	mov	  r12,r0		
		
	ldr	  r0, = ppupageindex
	mov	  r6,r1
	str	  r6,[r0]
	
 @@r6= Vnes.PPUPageIndex 	
	
	ldr	  r0, = ppuRegs
	ldrb	  r1,[r0,#REG_CTRL1]
 @@test if BG drawing is on
	tst	  r1,#REGF_CTRL1_BGON
	beq	  end_ppu_renderBGLineaBGOFF
	 		
 @@bg_offset = (ppuRegs[REG_CTRL0] & REGF_CTRL0_BGADDR) ? 0x1000 : 0;	
	ldrb	  r1,[r0,#REG_CTRL0]
	tst	  r1,#REGF_CTRL0_BGADDR
	movne	  r11,#0x1000
	moveq	  r11,#0
	
 @@sauvegarde pour BGCLIP a la fin
	stmfd	  r13!,{r12}
	
 @@buf_ptr = buffer + 8 - ppuTileXOfs
 	ldr	  r0, = ppuTileXOfs
 	add	  r12,r12,#8
 	ldrb	  r0,[r0] 	
 	sub	  r12,r12,r0	
	
 @@r0 = ppuVAddr	
	ldr	  r0, = ppuVAddr
 	ldr	  r0,[r0]
 @@bg_offset += ((ppuVAddr >> 12) & 7);	
 	mov	  r1,r0,lsr #12
 	and	  r1,r1,#7
 	add	  r11,r11,r1
 @@refresh_vaddr = 0x2000 + (ppuVAddr & 0x0fe0);
 	and	  r10,r0,#0xFE0
 	orr	  r10,r10,#0x2000
 @@y_tile = (ppuVAddr >> 5) & 0x1f;
 	mov	  r9,r0,lsr #5
 	and	  r9,r9,#0x1F
 @@x_tile = ppuVAddr & 0x1f;
	and	  r8,r0,#0x1F
	
 @@attrib_shift = (x_tile & 2) + ((y_tile & 2) << 1);
	and	  r7,r8,#2
	and	  r5,r9,#2
	orr	  r7,r7,r5,lsl #1
 @@attrib_base = (refresh_vaddr & 0x2c00) + 0x3c0 + ((y_tile & 0x1c) << 1);
 	and	  r5,r10,#0x2C00
 	orr	  r5,r5,#0x3C0
 	and	  r9,r9,#0x1C
 	orr	  r9,r5,r9,lsl #1

 
 
 @@tile_ptr = &Vnes.PPUPageIndex[(refresh_vaddr + x_tile)>>10][(refresh_vaddr + x_tile)&0x3ff];
 	add	  r5,r8,r10
 	mov	  r0,r5,lsr #10 	
 	ldr	  r1,[r6,r0,lsl #2] 	
 	sub	  r5,r5,r0,lsl #10
 	add	  r5,r5,r1 
 @@attrib_ptr = &Vnes.PPUPageIndex[(attrib_base + (x_tile >> 2))>>10][(attrib_base + (x_tile >> 2))&0x3ff];	
 	add	  r4,r9,r8,lsr #2
 	mov	  r0,r4,lsr #10 	
 	ldr	  r1,[r6,r0,lsl #2]
 	sub	  r4,r4,r0,lsl #10
 	add	  r4,r4,r1
 	
 	 	
		
	stmfd	  r13!,{r8-r10}
	
	ldr	  r9, = ppu_latchfunc
	ldr	  r9,[r9]	
	
	tst	  r8,#1
	beq	  looprenderBG
	bic	  r8,r8,#1
	
	ldrb	  r10,[r4]
 	mov	  r10,r10,lsr r7
 	and	  r10,r10,#3
 	mov	  r10,r10,lsl #2 	 	
	b	  partB	  		  	
		
   looprenderBG:    	   
   @@colrow
   	ldrb	  r10,[r4]
 	mov	  r10,r10,lsr r7
 	and	  r10,r10,#3
 	mov	  r10,r10,lsl #2 	
   	        
  @@tile_index = *tile_ptr++; 	
 	ldrb	  r0,[r5],#1
 	
 	orrs	  r9,r9,r9
 	beq	  nolatchleft1
 	stmfd     r13!,{r4-r12,lr}
	mov	  r0,r11	
	ldr	  r2, = ppu_latchfunc	
	ldr	  lr, = BGlatchfunc_retleft
	ldr	  pc,[r2]
BGlatchfunc_retleft:	    	
	ldmfd     r13!,{r4-r12,lr}
nolatchleft1:	
			
@@data_ptr = &Vnes.PPUPageIndex[(bg_offset + tile_index * 16)>>10][(bg_offset + tile_index * 16)&0x3ff];
        add	  r2,r11,r0,lsl #4
        mov	  r0,r2,lsr #10
        ldr	  r1,[r6,r0,lsl #2]
        bic	  r2,r2,#0x1C00
        add	  r2,r2,r1
                        
     	
     	stmfd	  r13!,{r5-r7}
     	ldrb	  r0,[r2]
     	ldrb	  r1,[r2,#8]
   @@draw a tile     	
   @@ r12=buffer  r1=pat0  r2=pat1  r8=colRow
 	orrs	  r1,r0,r1,lsl #8
 	beq	  5432f
     	        		
   	ldr	  r3, = patternTOpix 	   	
   	mov	  r0,r1,lsl #5
   	add	  r0,r0,r10,lsl #1
   	add	  r3,r3,r0   	   	
   	ldr	  r1,[r3]
   	ldr	  r2,[r3,#4]   	   	   	   	
   	strb    r1,[r12]
   	strb      r2,[r12,#4]
   	mov	  r1,r1,lsr #8
   	mov	  r2,r2,lsr #8
   	strb      r1,[r12,#1]   	
   	strb      r2,[r12,#5]
   	mov	  r1,r1,lsr #8
   	mov	  r2,r2,lsr #8
   	strb      r1,[r12,#2]   	
   	strb      r2,[r12,#6]
   	mov	  r1,r1,lsr #8
   	mov	  r2,r2,lsr #8
   	strb      r1,[r12,#3]   	
   	strb      r2,[r12,#7]
   	
 	b	  9876f
5432:
        strb	  r10,[r12]
        strb	  r10,[r12,#1]
        strb	  r10,[r12,#2]
        strb	  r10,[r12,#3]
        strb	  r10,[r12,#4]
        strb	  r10,[r12,#5]
        strb	  r10,[r12,#6]
        strb	  r10,[r12,#7]
9876: 
     	ldmfd     r13!,{r5-r7}
  @@buf_ptr += 8;     	
     	add	  r12,r12,#8  	  	
partB:	
  	  
  @@tile_index = *tile_ptr++; 	
 	ldrb	  r0,[r5],#1			
 	
 	orrs	  r9,r9,r9
 	beq	  nolatchleft2
 	stmfd     r13!,{r4-r12,lr}
	mov	  r0,r11	
	ldr	  r2, = ppu_latchfunc	
	ldr	  lr, = BGlatchfunc_retleft2
	ldr	  pc,[r2]
BGlatchfunc_retleft2:	    	
	ldmfd     r13!,{r4-r12,lr}
nolatchleft2:	
 	
 	
@@data_ptr = &Vnes.PPUPageIndex[(bg_offset + tile_index * 16)>>10][(bg_offset + tile_index * 16)&0x3ff];
        add	  r2,r11,r0,lsl #4
        mov	  r0,r2,lsr #10
        ldr	  r1,[r6,r0,lsl #2]
        bic	  r2,r2,#0x1C00
        add	  r2,r2,r1
     	
     	stmfd	  r13!,{r5-r7}
     	ldrb	  r0,[r2]
     	ldrb	  r1,[r2,#8]
   @@draw a tile     	
   @@ r12=buffer  r1=pat0  r2=pat1  r8=colRow       	 	
 	orrs	  r1,r0,r1,lsl #8
 	beq	  _5432B_ 	 	
     	        		     	        	     	      	
   	ldr	  r3, = patternTOpix 	   	
   	mov	  r0,r1,lsl #5
   	add	  r0,r0,r10,lsl #1
   	add	  r3,r3,r0   	   	
   	ldr	  r1,[r3]
   	ldr	  r2,[r3,#4]   	   	   	   	
   	strb    r1,[r12]
   	strb      r2,[r12,#4]
   	mov	  r1,r1,lsr #8
   	mov	  r2,r2,lsr #8
   	strb      r1,[r12,#1]   	
   	strb      r2,[r12,#5]
   	mov	  r1,r1,lsr #8
   	mov	  r2,r2,lsr #8
   	strb      r1,[r12,#2]   	
   	strb      r2,[r12,#6]
   	mov	  r1,r1,lsr #8
   	mov	  r2,r2,lsr #8
   	strb      r1,[r12,#3]   	
   	strb      r2,[r12,#7]   	
 	b	  _9876B_
_5432B_:
        strb	  r10,[r12]
        strb	  r10,[r12,#1]
        strb	  r10,[r12,#2]
        strb	  r10,[r12,#3]
        strb	  r10,[r12,#4]
        strb	  r10,[r12,#5]
        strb	  r10,[r12,#6]
        strb	  r10,[r12,#7]
_9876B_: 
     	ldmfd     r13!,{r5-r7}  
     	
        add	  r8,r8,#2
@@buf_ptr += 8;     	        
     	add	  r12,r12,#8  
  	  
  @@if (0 == (x_tile & 3))       	
  	tst       r8,#3  	
  @@attrib_ptr++;
  	addeq     r4,r4,#1
  @@attrib_shift ^= 2;    	
  	eor	  r7,r7,#2
 	@@if (32 == x_tile)  	 	
  	cmp	  r8,#32
  	bne	  looprenderBG		
  	
  	ldmfd	  r13!,{r8-r10}
  	orrs	  r8,r8,r8
  	beq	  end_ppu_renderBGLinea
  	
  	add	  r8,r8,#1

	eor	  r10,r10,#0x400
	eor	  r9,r9,#0x400
  @@tile_ptr = &Vnes.PPUPageIndex[(refresh_vaddr)>>10][(refresh_vaddr)&0x3ff];	
 	mov	  r0,r10,lsr #10
 	ldr	  r1,[r6,r0,lsl #2]
 	sub	  r5,r10,r0,lsl #10
 	add	  r5,r5,r1
  @@attrib_ptr = &Vnes.PPUPageIndex[(attrib_base)>>10][(attrib_base)&0x3ff]; 	
 	mov	  r0,r9,lsr #10
 	ldr	  r1,[r6,r0,lsl #2]
 	sub	  r4,r9,r0,lsl #10
 	add	  r4,r4,r1
 	
 	ldr	  r9, = ppu_latchfunc
 	ldr	  r9,[r9]
 	
looprenderBGright:
	.REPT     2
	
	ldrb	  r10,[r4]
 	mov	  r10,r10,lsr r7
 	and	  r10,r10,#3
 	mov	  r10,r10,lsl #2			
	.REPT     2
  @@tile_index = *tile_ptr++; 	
 	ldrb	  r0,[r5],#1
 	
 	orrs	  r9,r9,r9
 	beq	  9989f
 	stmfd     r13!,{r4-r12,lr}
	mov	  r0,r11	
	ldr	  r2, = ppu_latchfunc	
	ldr	  lr, = 9988f
	ldr	  pc,[r2]
9988:	    	
	ldmfd     r13!,{r4-r12,lr}
9989:	
			
@@data_ptr = &Vnes.PPUPageIndex[(bg_offset + tile_index * 16)>>10][(bg_offset + tile_index * 16)&0x3ff];
        add	  r2,r11,r0,lsl #4
        mov	  r0,r2,lsr #10
        ldr	  r1,[r6,r0,lsl #2]
        bic	  r2,r2,#0x1C00
        add	  r2,r2,r1
     	
     	stmfd	  r13!,{r5-r7}
     	ldrb	  r0,[r2]
     	ldrb	  r1,[r2,#8]
   @@draw a tile     	
   @@ r12=buffer  r1=pat0  r2=pat1  r8=colRow
   
        orrs	  r1,r0,r1,lsl #8
 	beq	  33668f
     	        	     	
   	ldr	  r3, = patternTOpix 	   	
   	mov	  r0,r1,lsl #5
   	add	  r0,r0,r10,lsl #1
   	add	  r3,r3,r0   	   	
   	ldr	  r1,[r3]
   	ldr	  r2,[r3,#4]   	   	   	   	
   	strb      r1,[r12]
   	strb      r2,[r12,#4]
   	mov	  r1,r1,lsr #8
   	mov	  r2,r2,lsr #8
   	strb      r1,[r12,#1]   	
   	strb      r2,[r12,#5]
   	mov	  r1,r1,lsr #8
   	mov	  r2,r2,lsr #8
   	strb      r1,[r12,#2]   	
   	strb      r2,[r12,#6]
   	mov	  r1,r1,lsr #8
   	mov	  r2,r2,lsr #8
   	strb      r1,[r12,#3]   	
   	strb      r2,[r12,#7]
   	
 	b	  33669f
33668:
        strb	  r10,[r12]
        strb	  r10,[r12,#1]
        strb	  r10,[r12,#2]
        strb	  r10,[r12,#3]
        strb	  r10,[r12,#4]
        strb	  r10,[r12,#5]
        strb	  r10,[r12,#6]
        strb	  r10,[r12,#7]
33669: 
     	ldmfd     r13!,{r5-r7}
  @@buf_ptr += 8;     	
     	add	  r12,r12,#8  	  	     	
     	subs	  r8,r8,#1  	  	
	beq	  end_ppu_renderBGLinea	
	.ENDR
@@attrib_shift ^= 2;	
	eor	  r7,r7,#2
	.ENDR  	
  	add       r4,r4,#1    	
	b	  looprenderBGright 	 	 	 	
  	
		
end_ppu_renderBGLinea:


	ldmfd	  r13!,{r12}
	ldr	  r0, = ppuRegs
 	ldrb	  r1,[r0,#REG_CTRL1]
	tst	  r1,#REGF_CTRL1_BGNOCLIP	
	moveq	  r2,#0
	streq	  r2,[r12,#8]
	streq	  r2,[r12,#12]	

	ldmfd	  r13!,{r4-r11}
	@@bx	  lr
	mov	  pc,lr
	
end_ppu_renderBGLineaBGOFF:	
	mov	  r0,#0
	add	  r12,r12,#8
	.REPT     64
	str	  r0,[r12],#4
	.ENDR
	ldmfd	  r13!,{r4-r11}
	@@bx	  lr
	mov	  pc,lr	
	
	.ALIGN    4
ppupageindex:
	.long   0		
colrow:
	.long   0	
	
	.pool
	