
#include "neopop.h"
#include "TLCS900H.h"
#include "Z80_interface.h"
//#include "Z80_sms.h"

#include "interrupt.h"
#include "mem.h"

//=============================================================================

// ZJ - set this!!
BOOL language_english=TRUE;

COLOURMODE system_colour;

_u8 frameskip_count;

//=============================================================================

int min(int x,int y)
{
if (y<x) return y;
return x;
}

//=============================================================================

void instruction_error(char* vaMessage,...)
{

}


void emulate(int accuracy)
{	
	
	switch (accuracy)
	{
		int i=64;
		case 0:
	    while ( i-- )
    	{       
        	updateTimers(doTLCS900H_Comp());
        	if (Z80ACTIVE) {Z80EMULATE}
        	updateTimers(doTLCS900H_Comp());
        }
        break;
        case 1:
	    while ( i-- )
    	{       
        	updateTimers(doTLCS900H_Z80_Med());
        }
        break;
        case 2:
	    while ( i-- )
    	{       
        	updateTimers(doTLCS900H_Z80_Fast());
        }
        break;
     }
   
}


void emulate_ns(int accuracy)
{
	
    switch (accuracy)
	{
		int i=64;	
		case 0:
	    while ( i-- )
    	{       
        	updateTimers(doTLCS900H_Comp());
        }
        break;
        case 1:
	    while ( i-- )
    	{       
        	updateTimers(doTLCS900H_Med());
        }
        break;
        case 2:
	    while ( i-- )
    	{       
        	updateTimers(doTLCS900H_Fast());
        }
        break;
     }
   
}


//=============================================================================
/*
void emulate(void)
{
	_u8 i;
//	int t;
	//Execute several instructions to boost performance

    // ATTENTION ENLEVER
	for (i = 0; i <64 ; i++)
//	for (i = 0; i <32 ; i++)
	{
//		t=0;

//     t+=TLCS900h_interpret();
 updateTimers(TLCS900h_interpret());
     if (Z80ACTIVE)	 Z80EMULATE
 updateTimers(TLCS900h_interpret());

//     t+=TLCS900h_interpret();
//     if (Z80ACTIVE)	 Z80EMULATE

//    updateTimers(t);
	}
}
*/