#ifndef __polyfiller_h__
#define __polyfiller_h__

#include "3dngine.h"

int poly_init(Vertex *v,Triangle *t,int32 *fdiv);
void poly_deinit(void);

void drawTriangle(int32 tri_index,uint16 col,uint16 *vbuffer);
void drawTriangleGouraud(int32 tri_index,int32 gour_pal,uint16 *vbuffer);
void drawTriangleTexture(int32 tri_index,int32 env_mapping,uint16 *vbuffer,uint16 *texture);
void drawTriangleCorTexture(int32 tri_index,int32 env_mapping,uint16 *vbuffer,uint16 *texture);

void drawTriangleDoubleTexture(int32 tri_index,uint16 *vbuffer,uint16 *tex1,uint16 *tex2);


#endif