
///////////////////////////
// En cours de modif...Poke
///////////////////////////

void gfx_draw_scanline_colour_bad(void)
{
  int	x;
  int 	i;
  _u8* 	ramOff7 = (ram + 0x8200);
  int	maxx;
  _u16*	fptr;
  _u16*	fptrend;
  int	fillcnt;
  _u16*	fillptr;
  _u16	filldata16;
  _u32	filldata32;

  _u8*	ppalsel;
  _u8*	pbitmap;
  _u8*	ppals;
 
  _u16	data32;
  _u8	sy;
  _u8	sx;
  _u8	lastSpriteY;
  _u8	lastSpriteX;

  _u32*	pspr;
  _u32*	psprA = (_u32*)(_u8*)(ram+0x8800);
  
  //Get the current scanline
  scanline = ram[0x8009];
    
  cfb_scanline = cfb + ((uint)scanline<<7) + ((uint)scanline<<5);  //Calculate fast offset (*160)

// ATTENTION ENLEVER

  //Window colour
  filldata16 = *(_u16*)(ram + 0x83F0 + (oowc << 1));

  //Ignore above and below the window's top and bottom
  if ( scanline >= winy && scanline < winy + winh) {
    //Background colour Enabled?  HACK: 01 AUG 2002 - Always on!
    // ATTENTION REMIS
    //if ((bgc & 0xC0) == 0x80)
    //{
      filldata16 = *(_u16*)(_u8*)(ram + 0x83E0 + ((bgc & 7) << 1));
    //}
    //else data16 = 0;

  //Draw background!
    fillcnt 	= min(winx+winw, SCREEN_WIDTH)-winx;
    filldata32 	= (((int)filldata16)<<16)|filldata16;
    fillptr		= cfb_scanline+winx;
    
    if ( ((int)fillptr)&2 )
    {
    	*((_u16*)fillptr)++ = filldata16;
    	fillcnt--;
    }
    while (fillcnt>=4)
    {
    	*((_u32*)fillptr)++ = filldata32;
    	*((_u32*)fillptr)++ = filldata32;
	    fillcnt-=4;
    }
    while (fillcnt>0)
    {
    	*((_u16*)fillptr)++ = filldata16;
    	fillcnt--;
    }
  	
  
	// On tri les sprites...
	//	gfx_sprite_sort();

	// Background sprites (level1)
	lastSpriteY = 0;
	lastSpriteX = 0;
    for (pspr=psprA+63; pspr>=psprA; )
    {
		data32 	= *pspr--;
		// Zone de priorit ?
		if ( ((data32>>11)&3) != 1 )
			continue;
        //calcul positionnement Y
		sy	= data32>>24;        	
        if (data32 & 0x0200)
           sy += lastSpriteY;  //Vertical chain?
        lastSpriteY = sy;
        sy += scrollspry;
        //Ce sprite est dans les bornes ?
        sy = scanline-sy;
        if ( sy&0xF8 )	//Pas visible sur cette ligne
        	continue;
		if ( data32&0x4000 ) //FlipY
			sy ^= 7;
        //calcul positionnement X
		sx	= data32>>16;        	
        if (data32 & 0x0400)
           sx += lastSpriteX; //Horizontal chain?
        lastSpriteX = sx;
        sx += scrollspry;
	
		//Selection de palette
		ppalsel	= ram+0x8C00+(pspr-psprA);
		ppals	= ram+0x8200+(((*ppalsel)&0xF)<<3);
		//Adresse de base des bitmap
		pbitmap	= ram+0xA000+((data32&0x1FF)<<4)+(sy<<1);
		NewDrawTileLine( cfb_scanline, x, *(_u16*)pbitmap,	ppals, data32&0x8000 );
    }

	// Plane background
	if (planeSwap)
	   gfx_draw_scroll1();
	else
	   gfx_draw_scroll2();

	// Middle sprites (level2)
	lastSpriteY = 0;
	lastSpriteX = 0;
    for (pspr=psprA+63; pspr>=psprA; )
    {
		data32 	= *pspr--;
		// Zone de priorit ?
		if ( ((data32>>11)&3) != 2 )
			continue;
        //calcul positionnement Y
		sy	= data32>>24;        	
        if (data32 & 0x0200)
           sy += lastSpriteY;  //Vertical chain?
        lastSpriteY = sy;
        sy += scrollspry;
        //Ce sprite est dans les bornes ?
        sy = scanline-sy;
        if ( sy&0xF8 )	//Pas visible sur cette ligne
        	continue;
		if ( data32&0x4000 ) //FlipY
			sy ^= 7;
        //calcul positionnement X
		sx	= data32>>16;        	
        if (data32 & 0x0400)
           sx += lastSpriteX; //Horizontal chain?
        lastSpriteX = sx;
        sx += scrollspry;
	
		//Selection de palette
		ppalsel	= ram+0x8C00+(pspr-psprA);
		ppals	= ram+0x8200+(((*ppalsel)&0xF)<<3);
		//Adresse de base des bitmap
		pbitmap	= ram+0xA000+((data32&0x1FF)<<4)+(sy<<1);
		NewDrawTileLine( cfb_scanline, x, *(_u16*)pbitmap,	ppals, data32&0x8000 );
    }

	//Plane foreground
	if (!planeSwap)
	   gfx_draw_scroll1();
	else
	   gfx_draw_scroll2();

	// Top sprites (level3)
	lastSpriteY = 0;
	lastSpriteX = 0;
    for (pspr=psprA+63; pspr>=psprA; )
    {
		data32 	= *pspr--;
		// Zone de priorit ?
		if ( ((data32>>11)&3) != 3 )
			continue;
        //calcul positionnement Y
		sy	= data32>>24;        	
        if (data32 & 0x0200)
           sy += lastSpriteY;  //Vertical chain?
        lastSpriteY = sy;
        sy += scrollspry;
        //Ce sprite est dans les bornes ?
        sy = scanline-sy;
        if ( sy&0xF8 )	//Pas visible sur cette ligne
        	continue;
		if ( data32&0x4000 ) //FlipY
			sy ^= 7;
        //calcul positionnement X
		sx	= data32>>16;        	
        if (data32 & 0x0400)
           sx += lastSpriteX; //Horizontal chain?
        lastSpriteX = sx;
        sx += scrollspry;
	
		//Selection de palette
		ppalsel	= ram+0x8C00+(pspr-psprA);
		ppals	= ram+0x8200+(((*ppalsel)&0xF)<<3);
		//Adresse de base des bitmap
		pbitmap	= ram+0xA000+((data32&0x1FF)<<4)+(sy<<1);
		NewDrawTileLine( cfb_scanline, x, *(_u16*)pbitmap,	ppals, data32&0x8000 );
    }
  }
}



//=============================================================================



//=============================================================================
/*
#define Plot(x,palette_ptr,palette,index,depth) {
 if (!(index == 0 || x < winx || x >= (winw +   winx) || x >= SCREEN_WIDTH))    \
  return;                                     \                                           \
 if (depth > zbuffer[x])                              \
  return ;                                      \   
 zbuffer[x] = depth;                                \ 
 cfb_scanline[x] = negative?~palette_ptr[(palette << 2) + index]:palette_ptr[(palette << 2) + index];
}
*/

//#define Plot(x,palette_ptr,palette,index,depth) { if (!(index == 0 || x < winx || x >= (winw + winx) || x >= SCREEN_WIDTH)) if (depth > zbuffer[x]) { zbuffer[x] = depth; cfb_scanline[x] = negative?~palette_ptr[(palette << 2) + index]:palette_ptr[(palette << 2) + index]; }

static __inline void Plot2(_u8 x, _u16* palette_ptr, _u8 palette, _u8 index, _u8 depth)
{
  _u16 data16;

  //Clip
	  if (index == 0 /*transparent*/|| x < winx || x >= (winw + winx) || x >= SCREEN_WIDTH)
    return;

  //Depth check, <= to stop later sprites overwriting pixels!
  if (depth <= zbuffer[x])
    return;
  zbuffer[x] = depth;

  //Get the colour of the pixel
  data16 = palette_ptr[(palette << 2) + index];

  if (negative)
    cfb_scanline[x] = ~data16;
  else
    cfb_scanline[x] = data16;
}


static __inline void drawPattern(_u8 screenx, _u16 tile, _u8 tiley, _u16 mirror,
                                 _u16* palette_ptr, _u8 pal, _u8 depth)
{
	
  //Get the data for the "tiley'th" line of "tile".
  //_u16 data = *(_u16*)(ram + 0xA000 + (tile * 16) + (tiley * 2));
  _u16 data = *(_u16*)(ram + 0xA000 + (tile << 4) + (tiley << 1));
  NewDrawTileLine( cfb_scanline,screenx, data, palette_ptr+(pal<<2), tile&0x8000 );

}

static __inline void drawPattern2(_u8 screenx, _u16 tile, _u8 tiley, _u16 mirror,
                                 _u16* palette_ptr, _u8 pal, _u8 depth)
{
  //Get the data for the "tiley'th" line of "tile".
  //_u16 data = *(_u16*)(ram + 0xA000 + (tile * 16) + (tiley * 2));
  _u16 data = *(_u16*)(ram + 0xA000 + (tile << 4) + (tiley << 1));

  //Horizontal Flip
  if (mirror) {
    Plot2(screenx + 7, palette_ptr, pal, (data & 0xC000) >> 0xE, depth);
    Plot2(screenx + 6, palette_ptr, pal, (data & 0x3000) >> 0xC, depth);
    Plot2(screenx + 5, palette_ptr, pal, (data & 0x0C00) >> 0xA, depth);
    Plot2(screenx + 4, palette_ptr, pal, (data & 0x0300) >> 0x8, depth);
    Plot2(screenx + 3, palette_ptr, pal, (data & 0x00C0) >> 0x6, depth);
    Plot2(screenx + 2, palette_ptr, pal, (data & 0x0030) >> 0x4, depth);
    Plot2(screenx + 1, palette_ptr, pal, (data & 0x000C) >> 0x2, depth);
    Plot2(screenx + 0, palette_ptr, pal, (data & 0x0003) >> 0x0, depth);
  }
  else {
    // Normal
    Plot2(screenx + 0, palette_ptr, pal, (data & 0xC000) >> 0xE, depth);
    Plot2(screenx + 1, palette_ptr, pal, (data & 0x3000) >> 0xC, depth);
    Plot2(screenx + 2, palette_ptr, pal, (data & 0x0C00) >> 0xA, depth);
    Plot2(screenx + 3, palette_ptr, pal, (data & 0x0300) >> 0x8, depth);
    Plot2(screenx + 4, palette_ptr, pal, (data & 0x00C0) >> 0x6, depth);
    Plot2(screenx + 5, palette_ptr, pal, (data & 0x0030) >> 0x4, depth);
    Plot2(screenx + 6, palette_ptr, pal, (data & 0x000C) >> 0x2, depth);
    Plot2(screenx + 7, palette_ptr, pal, (data & 0x0003) >> 0x0, depth);
  }
}

/*
static __inline void gfx_draw_scroll1(_u8 depth)
{
	_u8 tx, row, line;
	_u16 data16;

	_u16 line2;
	_u8 *ramOff7, *ramOff7_2;
	
	line = scanline + scroll1y;
	row = line & 7;	//Which row?
	
	ramOff7 = ram + 0x9000;
	ramOff7_2 = ram + 0x8280;
	line2 = ((line >> 3) << 5);
   
	//Draw Foreground scroll plane (Scroll 1)
	for (tx = 0; tx < 32; tx++)	{
		data16 = *(_u16*)(ramOff7 + ((tx + line2) << 1));
			
		//Draw the line of the tile
		drawPattern((tx << 3) - scroll1x, data16 & 0x01FF, 
			(data16 & 0x4000) ? (7 - row) : row, data16 & 0x8000, (_u16*)(ramOff7_2),
			(data16 & 0x1E00) >> 9, depth);
	}
}
*/





static __inline void gfx_draw_scroll12(_u8 depth)
{
	_u8 tx, row, line;
	_u16 line2;
	_u8 *ramOff7, *ramOff7_2;
	_u16 data16[32];

	line = scanline + scroll1y;
	row = line & 7;	//Which row?
	ramOff7 = ram + 0x9000;
	ramOff7_2 = ram + 0x8280;
	line2 = ((line >> 3) << 5);
	
	ramOff7 = ramOff7 + (line2 << 1);
 
	//Draw Foreground scroll plane (Scroll 1)
	data16[0] = *(_u16*)(ramOff7);
	data16[1] = *(_u16*)(ramOff7 + 2);
	data16[2] = *(_u16*)(ramOff7 + 4);
	data16[3] = *(_u16*)(ramOff7 + 6);
	data16[4] = *(_u16*)(ramOff7 + 8);
	data16[5] = *(_u16*)(ramOff7 + 10);
	data16[6] = *(_u16*)(ramOff7 + 12);
	data16[7] = *(_u16*)(ramOff7 + 14);
	data16[8] = *(_u16*)(ramOff7 + 16);
	data16[9] = *(_u16*)(ramOff7 + 18);

	data16[10] = *(_u16*)(ramOff7 + 20);
	data16[11] = *(_u16*)(ramOff7 + 22);
	data16[12] = *(_u16*)(ramOff7 + 24);
	data16[13] = *(_u16*)(ramOff7 + 26);
	data16[14] = *(_u16*)(ramOff7 + 28);
	data16[15] = *(_u16*)(ramOff7 + 30);
	data16[16] = *(_u16*)(ramOff7 + 32);
	data16[17] = *(_u16*)(ramOff7 + 34);
	data16[18] = *(_u16*)(ramOff7 + 36);
	data16[19] = *(_u16*)(ramOff7 + 38);

	data16[20] = *(_u16*)(ramOff7 + 40);
	data16[21] = *(_u16*)(ramOff7 + 42);
	data16[22] = *(_u16*)(ramOff7 + 44);
	data16[23] = *(_u16*)(ramOff7 + 46);
	data16[24] = *(_u16*)(ramOff7 + 48);
	data16[25] = *(_u16*)(ramOff7 + 50);
	data16[26] = *(_u16*)(ramOff7 + 52);
	data16[27] = *(_u16*)(ramOff7 + 54);
	data16[28] = *(_u16*)(ramOff7 + 56);
	data16[29] = *(_u16*)(ramOff7 + 58);

	data16[30] = *(_u16*)(ramOff7 + 60);
	data16[31] = *(_u16*)(ramOff7 + 62);
		
	//Draw the line of the tile
 
     drawPattern2(0-scroll1x,data16[0]&0x01FF,(data16[0]&0x4000)?(7-row):row,data16[0]&0x8000,(_u16*)(ramOff7_2),(data16[0]&0x1E00)>>9,depth);
     drawPattern2(8-scroll1x,data16[1]&0x01FF,(data16[1]&0x4000)?(7-row):row,data16[1]&0x8000,(_u16*)(ramOff7_2),(data16[1]&0x1E00)>>9,depth);
     drawPattern2(8-scroll1x,data16[1]&0x01FF,(data16[1]&0x4000)?(7-row):row,data16[1]&0x8000,(_u16*)(ramOff7_2),(data16[1]&0x1E00)>>9,depth);
     drawPattern2(16-scroll1x,data16[2]&0x01FF,(data16[2]&0x4000)?(7-row):row,data16[2]&0x8000,(_u16*)(ramOff7_2),(data16[2]&0x1E00)>>9,depth);
     drawPattern2(24-scroll1x,data16[3]&0x01FF,(data16[3]&0x4000)?(7-row):row,data16[3]&0x8000,(_u16*)(ramOff7_2),(data16[3]&0x1E00)>>9,depth);
     drawPattern2(32-scroll1x,data16[4]&0x01FF,(data16[4]&0x4000)?(7-row):row,data16[4]&0x8000,(_u16*)(ramOff7_2),(data16[4]&0x1E00)>>9,depth);
     drawPattern2(40-scroll1x,data16[5]&0x01FF,(data16[5]&0x4000)?(7-row):row,data16[5]&0x8000,(_u16*)(ramOff7_2),(data16[5]&0x1E00)>>9,depth);
     drawPattern2(48-scroll1x,data16[6]&0x01FF,(data16[6]&0x4000)?(7-row):row,data16[6]&0x8000,(_u16*)(ramOff7_2),(data16[6]&0x1E00)>>9,depth);
     drawPattern2(56-scroll1x,data16[7]&0x01FF,(data16[7]&0x4000)?(7-row):row,data16[7]&0x8000,(_u16*)(ramOff7_2),(data16[7]&0x1E00)>>9,depth);
     drawPattern2(64-scroll1x,data16[8]&0x01FF,(data16[8]&0x4000)?(7-row):row,data16[8]&0x8000,(_u16*)(ramOff7_2),(data16[8]&0x1E00)>>9,depth);
     drawPattern2(72-scroll1x,data16[9]&0x01FF,(data16[9]&0x4000)?(7-row):row,data16[9]&0x8000,(_u16*)(ramOff7_2),(data16[9]&0x1E00)>>9,depth);

     drawPattern2(80-scroll1x,data16[10]&0x01FF,(data16[10]&0x4000)?(7-row):row,data16[10]&0x8000,(_u16*)(ramOff7_2),(data16[10]&0x1E00)>>9,depth);
     drawPattern2(88-scroll1x,data16[11]&0x01FF,(data16[11]&0x4000)?(7-row):row,data16[11]&0x8000,(_u16*)(ramOff7_2),(data16[11]&0x1E00)>>9,depth);
     drawPattern2(96-scroll1x,data16[12]&0x01FF,(data16[12]&0x4000)?(7-row):row,data16[12]&0x8000,(_u16*)(ramOff7_2),(data16[12]&0x1E00)>>9,depth);
     drawPattern2(104-scroll1x,data16[13]&0x01FF,(data16[13]&0x4000)?(7-row):row,data16[13]&0x8000,(_u16*)(ramOff7_2),(data16[13]&0x1E00)>>9,depth);
     drawPattern2(112-scroll1x,data16[14]&0x01FF,(data16[14]&0x4000)?(7-row):row,data16[14]&0x8000,(_u16*)(ramOff7_2),(data16[14]&0x1E00)>>9,depth);
     drawPattern2(120-scroll1x,data16[15]&0x01FF,(data16[15]&0x4000)?(7-row):row,data16[15]&0x8000,(_u16*)(ramOff7_2),(data16[15]&0x1E00)>>9,depth);
     drawPattern2(128-scroll1x,data16[16]&0x01FF,(data16[16]&0x4000)?(7-row):row,data16[16]&0x8000,(_u16*)(ramOff7_2),(data16[16]&0x1E00)>>9,depth);
     drawPattern2(136-scroll1x,data16[17]&0x01FF,(data16[17]&0x4000)?(7-row):row,data16[17]&0x8000,(_u16*)(ramOff7_2),(data16[17]&0x1E00)>>9,depth);
     drawPattern2(144-scroll1x,data16[18]&0x01FF,(data16[18]&0x4000)?(7-row):row,data16[18]&0x8000,(_u16*)(ramOff7_2),(data16[18]&0x1E00)>>9,depth);
     drawPattern2(152-scroll1x,data16[19]&0x01FF,(data16[19]&0x4000)?(7-row):row,data16[19]&0x8000,(_u16*)(ramOff7_2),(data16[19]&0x1E00)>>9,depth);

     drawPattern2(160-scroll1x,data16[20]&0x01FF,(data16[20]&0x4000)?(7-row):row,data16[20]&0x8000,(_u16*)(ramOff7_2),(data16[20]&0x1E00)>>9,depth);
     drawPattern2(168-scroll1x,data16[21]&0x01FF,(data16[21]&0x4000)?(7-row):row,data16[21]&0x8000,(_u16*)(ramOff7_2),(data16[21]&0x1E00)>>9,depth);
     drawPattern2(176-scroll1x,data16[22]&0x01FF,(data16[22]&0x4000)?(7-row):row,data16[22]&0x8000,(_u16*)(ramOff7_2),(data16[22]&0x1E00)>>9,depth);
     drawPattern2(184-scroll1x,data16[23]&0x01FF,(data16[23]&0x4000)?(7-row):row,data16[23]&0x8000,(_u16*)(ramOff7_2),(data16[23]&0x1E00)>>9,depth);
     drawPattern2(192-scroll1x,data16[24]&0x01FF,(data16[24]&0x4000)?(7-row):row,data16[24]&0x8000,(_u16*)(ramOff7_2),(data16[24]&0x1E00)>>9,depth);
     drawPattern2(200-scroll1x,data16[25]&0x01FF,(data16[25]&0x4000)?(7-row):row,data16[25]&0x8000,(_u16*)(ramOff7_2),(data16[25]&0x1E00)>>9,depth);
     drawPattern2(208-scroll1x,data16[26]&0x01FF,(data16[26]&0x4000)?(7-row):row,data16[26]&0x8000,(_u16*)(ramOff7_2),(data16[26]&0x1E00)>>9,depth);
     drawPattern2(216-scroll1x,data16[27]&0x01FF,(data16[27]&0x4000)?(7-row):row,data16[27]&0x8000,(_u16*)(ramOff7_2),(data16[27]&0x1E00)>>9,depth);
     drawPattern2(224-scroll1x,data16[28]&0x01FF,(data16[28]&0x4000)?(7-row):row,data16[28]&0x8000,(_u16*)(ramOff7_2),(data16[28]&0x1E00)>>9,depth);
     drawPattern2(232-scroll1x,data16[29]&0x01FF,(data16[29]&0x4000)?(7-row):row,data16[29]&0x8000,(_u16*)(ramOff7_2),(data16[29]&0x1E00)>>9,depth);

     drawPattern2(240-scroll1x,data16[30]&0x01FF,(data16[30]&0x4000)?(7-row):row,data16[30]&0x8000,(_u16*)(ramOff7_2),(data16[30]&0x1E00)>>9,depth);
     drawPattern2(248-scroll1x,data16[31]&0x01FF,(data16[31]&0x4000)?(7-row):row,data16[31]&0x8000,(_u16*)(ramOff7_2),(data16[31]&0x1E00)>>9,depth);
}


/*
static __inline void gfx_draw_scroll2(_u8 depth)
{
	_u8 tx, row, line;
	_u16 data16;
	
	// _u16 because of overflow risk
	_u16 line2;
	_u8 *ramOff7, *ramOff7_2;

	line = scanline + scroll2y;
	row = line & 7;	//Which row?

	ramOff7 = ram + 0x9800;
	ramOff7_2 = ram + 0x8300;
	line2 = ((line >> 3) << 5);

    
	//Draw Background scroll plane (Scroll 2)
	for (tx = 0; tx < 32; tx++)	{
		data16 = *(_u16*)(ramOff7 + ((tx + line2) << 1));
		
		//Draw the line of the tile
		drawPattern((tx << 3) - scroll2x, data16 & 0x01FF, 
			(data16 & 0x4000) ? (7 - row) : row, data16 & 0x8000, (_u16*)(ramOff7_2),
			(data16 & 0x1E00) >> 9, depth);
	}
}
*/

static __inline void gfx_draw_scroll22(_u8 depth)
{
	_u8 tx, row, line;
	_u16 line2;
	_u8 *ramOff7, *ramOff7_2;
	_u16 data16[32];


	line = scanline + scroll1y;
	row = line & 7;	//Which row?
	ramOff7 = ram + 0x9800;
	ramOff7_2 = ram + 0x8300;
	line2 = ((line >> 3) << 5);
	
	ramOff7 = ramOff7 + (line2 << 1);
 
	//Draw Foreground scroll plane (Scroll 2)
	data16[0] = *(_u16*)(ramOff7);
	data16[1] = *(_u16*)(ramOff7 + 2);
	data16[2] = *(_u16*)(ramOff7 + 4);
	data16[3] = *(_u16*)(ramOff7 + 6);
	data16[4] = *(_u16*)(ramOff7 + 8);
	data16[5] = *(_u16*)(ramOff7 + 10);
	data16[6] = *(_u16*)(ramOff7 + 12);
	data16[7] = *(_u16*)(ramOff7 + 14);
	data16[8] = *(_u16*)(ramOff7 + 16);
	data16[9] = *(_u16*)(ramOff7 + 18);

	data16[10] = *(_u16*)(ramOff7 + 20);
	data16[11] = *(_u16*)(ramOff7 + 22);
	data16[12] = *(_u16*)(ramOff7 + 24);
	data16[13] = *(_u16*)(ramOff7 + 26);
	data16[14] = *(_u16*)(ramOff7 + 28);
	data16[15] = *(_u16*)(ramOff7 + 30);
	data16[16] = *(_u16*)(ramOff7 + 32);
	data16[17] = *(_u16*)(ramOff7 + 34);
	data16[18] = *(_u16*)(ramOff7 + 36);
	data16[19] = *(_u16*)(ramOff7 + 38);

	data16[20] = *(_u16*)(ramOff7 + 40);
	data16[21] = *(_u16*)(ramOff7 + 42);
	data16[22] = *(_u16*)(ramOff7 + 44);
	data16[23] = *(_u16*)(ramOff7 + 46);
	data16[24] = *(_u16*)(ramOff7 + 48);
	data16[25] = *(_u16*)(ramOff7 + 50);
	data16[26] = *(_u16*)(ramOff7 + 52);
	data16[27] = *(_u16*)(ramOff7 + 54);
	data16[28] = *(_u16*)(ramOff7 + 56);
	data16[29] = *(_u16*)(ramOff7 + 58);

	data16[30] = *(_u16*)(ramOff7 + 60);
	data16[31] = *(_u16*)(ramOff7 + 62);
		

	//Draw the line of the tile
     drawPattern2(0-scroll1x,data16[0]&0x01FF,(data16[0]&0x4000)?(7-row):row,data16[0]&0x8000,(_u16*)(ramOff7_2),(data16[0]&0x1E00)>>9,depth);
     drawPattern2(8-scroll1x,data16[1]&0x01FF,(data16[1]&0x4000)?(7-row):row,data16[1]&0x8000,(_u16*)(ramOff7_2),(data16[1]&0x1E00)>>9,depth);
     drawPattern2(16-scroll1x,data16[2]&0x01FF,(data16[2]&0x4000)?(7-row):row,data16[2]&0x8000,(_u16*)(ramOff7_2),(data16[2]&0x1E00)>>9,depth);
     drawPattern2(24-scroll1x,data16[3]&0x01FF,(data16[3]&0x4000)?(7-row):row,data16[3]&0x8000,(_u16*)(ramOff7_2),(data16[3]&0x1E00)>>9,depth);
     drawPattern2(32-scroll1x,data16[4]&0x01FF,(data16[4]&0x4000)?(7-row):row,data16[4]&0x8000,(_u16*)(ramOff7_2),(data16[4]&0x1E00)>>9,depth);
     drawPattern2(40-scroll1x,data16[5]&0x01FF,(data16[5]&0x4000)?(7-row):row,data16[5]&0x8000,(_u16*)(ramOff7_2),(data16[5]&0x1E00)>>9,depth);
     drawPattern2(48-scroll1x,data16[6]&0x01FF,(data16[6]&0x4000)?(7-row):row,data16[6]&0x8000,(_u16*)(ramOff7_2),(data16[6]&0x1E00)>>9,depth);
     drawPattern2(56-scroll1x,data16[7]&0x01FF,(data16[7]&0x4000)?(7-row):row,data16[7]&0x8000,(_u16*)(ramOff7_2),(data16[7]&0x1E00)>>9,depth);
     drawPattern2(64-scroll1x,data16[8]&0x01FF,(data16[8]&0x4000)?(7-row):row,data16[8]&0x8000,(_u16*)(ramOff7_2),(data16[8]&0x1E00)>>9,depth);
     drawPattern2(72-scroll1x,data16[9]&0x01FF,(data16[9]&0x4000)?(7-row):row,data16[9]&0x8000,(_u16*)(ramOff7_2),(data16[9]&0x1E00)>>9,depth);

     drawPattern2(80-scroll1x,data16[10]&0x01FF,(data16[10]&0x4000)?(7-row):row,data16[10]&0x8000,(_u16*)(ramOff7_2),(data16[10]&0x1E00)>>9,depth);
     drawPattern2(88-scroll1x,data16[11]&0x01FF,(data16[11]&0x4000)?(7-row):row,data16[11]&0x8000,(_u16*)(ramOff7_2),(data16[11]&0x1E00)>>9,depth);
     drawPattern2(96-scroll1x,data16[12]&0x01FF,(data16[12]&0x4000)?(7-row):row,data16[12]&0x8000,(_u16*)(ramOff7_2),(data16[12]&0x1E00)>>9,depth);
     drawPattern2(104-scroll1x,data16[13]&0x01FF,(data16[13]&0x4000)?(7-row):row,data16[13]&0x8000,(_u16*)(ramOff7_2),(data16[13]&0x1E00)>>9,depth);
     drawPattern2(112-scroll1x,data16[14]&0x01FF,(data16[14]&0x4000)?(7-row):row,data16[14]&0x8000,(_u16*)(ramOff7_2),(data16[14]&0x1E00)>>9,depth);
     drawPattern2(120-scroll1x,data16[15]&0x01FF,(data16[15]&0x4000)?(7-row):row,data16[15]&0x8000,(_u16*)(ramOff7_2),(data16[15]&0x1E00)>>9,depth);
     drawPattern2(128-scroll1x,data16[16]&0x01FF,(data16[16]&0x4000)?(7-row):row,data16[16]&0x8000,(_u16*)(ramOff7_2),(data16[16]&0x1E00)>>9,depth);
     drawPattern2(136-scroll1x,data16[17]&0x01FF,(data16[17]&0x4000)?(7-row):row,data16[17]&0x8000,(_u16*)(ramOff7_2),(data16[17]&0x1E00)>>9,depth);
     drawPattern2(144-scroll1x,data16[18]&0x01FF,(data16[18]&0x4000)?(7-row):row,data16[18]&0x8000,(_u16*)(ramOff7_2),(data16[18]&0x1E00)>>9,depth);
     drawPattern2(152-scroll1x,data16[19]&0x01FF,(data16[19]&0x4000)?(7-row):row,data16[19]&0x8000,(_u16*)(ramOff7_2),(data16[19]&0x1E00)>>9,depth);

     drawPattern2(160-scroll1x,data16[20]&0x01FF,(data16[20]&0x4000)?(7-row):row,data16[20]&0x8000,(_u16*)(ramOff7_2),(data16[20]&0x1E00)>>9,depth);
     drawPattern2(168-scroll1x,data16[21]&0x01FF,(data16[21]&0x4000)?(7-row):row,data16[21]&0x8000,(_u16*)(ramOff7_2),(data16[21]&0x1E00)>>9,depth);
     drawPattern2(176-scroll1x,data16[22]&0x01FF,(data16[22]&0x4000)?(7-row):row,data16[22]&0x8000,(_u16*)(ramOff7_2),(data16[22]&0x1E00)>>9,depth);
     drawPattern2(184-scroll1x,data16[23]&0x01FF,(data16[23]&0x4000)?(7-row):row,data16[23]&0x8000,(_u16*)(ramOff7_2),(data16[23]&0x1E00)>>9,depth);
     drawPattern2(192-scroll1x,data16[24]&0x01FF,(data16[24]&0x4000)?(7-row):row,data16[24]&0x8000,(_u16*)(ramOff7_2),(data16[24]&0x1E00)>>9,depth);
     drawPattern2(200-scroll1x,data16[25]&0x01FF,(data16[25]&0x4000)?(7-row):row,data16[25]&0x8000,(_u16*)(ramOff7_2),(data16[25]&0x1E00)>>9,depth);
     drawPattern2(208-scroll1x,data16[26]&0x01FF,(data16[26]&0x4000)?(7-row):row,data16[26]&0x8000,(_u16*)(ramOff7_2),(data16[26]&0x1E00)>>9,depth);
     drawPattern2(216-scroll1x,data16[27]&0x01FF,(data16[27]&0x4000)?(7-row):row,data16[27]&0x8000,(_u16*)(ramOff7_2),(data16[27]&0x1E00)>>9,depth);
     drawPattern2(224-scroll1x,data16[28]&0x01FF,(data16[28]&0x4000)?(7-row):row,data16[28]&0x8000,(_u16*)(ramOff7_2),(data16[28]&0x1E00)>>9,depth);
     drawPattern2(232-scroll1x,data16[29]&0x01FF,(data16[29]&0x4000)?(7-row):row,data16[29]&0x8000,(_u16*)(ramOff7_2),(data16[29]&0x1E00)>>9,depth);

     drawPattern2(240-scroll1x,data16[30]&0x01FF,(data16[30]&0x4000)?(7-row):row,data16[30]&0x8000,(_u16*)(ramOff7_2),(data16[30]&0x1E00)>>9,depth);
     drawPattern2(248-scroll1x,data16[31]&0x01FF,(data16[31]&0x4000)?(7-row):row,data16[31]&0x8000,(_u16*)(ramOff7_2),(data16[31]&0x1E00)>>9,depth);
}

void gfx_draw_scanline_colour2(void)
{
//	cfbb[0] = 0;	//Pour s'assurer que les variables sont la
//	cfba[0] = 0;
	
  _s16 lastSpriteX;
  _s16 lastSpriteY;
  int spr, x;
  _u16 data16;
  
  /* +++ ---------- MODIFIED BY LOCK 27.03.2003 ---------- ++++ */
  _s16 scanline_minus_Y;
//  _u8 ramOff7;// TYPE A DEFINIR
  _u8* ramOff7;// TYPE A DEFINIR
  
  
//  ramOff7 = *(_u8*)(ram + 0x8200);
  ramOff7 = (ram + 0x8200);

  /* +++ ---------- MODIFIED BY LOCK 27.03.2003 ---------- ++++ */

  //Get the current scanline
  scanline = ram[0x8009];
  cfb_scanline = cfb + (scanline <<7) + (scanline << 5);  //Calculate fast offset
  memset(zbuffer, 0, SCREEN_WIDTH);

// ATTENTION ENLEVER

  //Window colour
  data16 = *(_u16*)(ram + 0x83F0 + (oowc << 1));
  
  if (negative)
    data16 = ~data16;

  //Top
  if (scanline < winy) {
    for (x = 0; x < SCREEN_WIDTH; x++)
      cfb_scanline[x] = data16;
  }
  else {
    //Middle
    if (scanline < winy + winh) {
      for (x = 0; x < min(winx, SCREEN_WIDTH); x++)
        cfb_scanline[x] = data16;

      for (x = min(winx + winw, SCREEN_WIDTH); x < SCREEN_WIDTH; x++)
        cfb_scanline[x] = data16;
    }
    else {
      //Bottom
      for (x = 0; x < SCREEN_WIDTH; x++)
        cfb_scanline[x] = data16;
    }
  }

  //Ignore above and below the window's top and bottom
  if ( scanline >= winy && scanline < winy + winh) {
    //Background colour Enabled?  HACK: 01 AUG 2002 - Always on!
    // ATTENTION REMIS
    //if ((bgc & 0xC0) == 0x80)
    //{
      data16 = *(_u16*)(_u8*)(ram + 0x83E0 + ((bgc & 7) << 1));
    //}
    //else data16 = 0;

    if (negative)
      data16 = ~data16;

    //Draw background!
    for (x = winx; x < min(winx + winw, SCREEN_WIDTH); x++)
      cfb_scanline[x] = data16;

    //Swap Front/Back scroll planes?
    if (planeSwap) {
      gfx_draw_scroll12(ZDEPTH_BACKGROUND_SCROLL);   //Swap
      gfx_draw_scroll22(ZDEPTH_FOREGROUND_SCROLL);
    }
    else {
      gfx_draw_scroll22(ZDEPTH_BACKGROUND_SCROLL);   //Normal
      gfx_draw_scroll12(ZDEPTH_FOREGROUND_SCROLL);
    }

    //Draw Sprites
    //Last sprite position, (defaults to top-left, sure?)
    lastSpriteX = 0;
    lastSpriteY = 0;
    
    for (spr = 0; spr < 64; spr++) {
      _u8 priority, row;
      _u16 data16;
      _u8 sx; //X position
      _u8 sy; //Y position
      _s16 x;
      _s16 y;
      
      int spr2;
      
      /* +++ ---------- MODIFIED BY LOCK 27.03.2003 ---------- ++++ */
    	spr2 = 0x8800 + (spr << 2);
    	/* +++ ---------- MODIFIED BY LOCK 27.03.2003 ---------- ++++ */
    	
      data16 = *(_u16*)(ram + spr2);
      priority = (data16 & 0x1800) >> 11;

      //Visible?
      if (priority == 0)
        continue;

      x = sx = ram[spr2 + 2];  //X position
      y = sy = ram[spr2 + 3];  //Y position
//      x = sx;
//      y = sy;

      if (data16 & 0x0400)
        x = lastSpriteX + sx;  //Horizontal chain?
      if (data16 & 0x0200)
        y = lastSpriteY + sy;  //Vertical chain?

      //Store the position for chaining
      lastSpriteX = x;
      lastSpriteY = y;

      //Scroll the sprite
      x += scrollsprx;
      y += scrollspry;

      //Off-screen?
      if (x > 248 && x < 256)
        x = x - 256;
      else x &= 0xFF;
      
      if (y > 248 && y < 256)
        y = y - 256;
      else y &= 0xFF;

			/* +++ ---------- MODIFIED BY LOCK 27.03.2003 ---------- ++++ */
      // Permet d'utiliser un test avec 0 et vite de calculer 3 fois scanline - y.
      // A moins que le compilo sauvegarde le rsultat de scanline - y ???
      scanline_minus_Y = scanline - y;
      
      //In range?
      if (scanline_minus_Y >= 0 && scanline_minus_Y <= 7) {
      /* +++ ---------- MODIFIED BY LOCK 27.03.2003 ---------- ++++ */	
      	
        row = scanline_minus_Y & 7; //Which row?
        
        drawPattern((_u8)x, data16 & 0x01FF, 
                    (data16 & 0x4000) ? 7 - row : row, data16 & 0x8000,
                    (_u16*)(ramOff7), ram[0x8C00 + spr] & 0xF, priority << 1);
      }

		//In range?
			//if (scanline >= y && scanline <= y + 7)
			//{
			//	row = (scanline - y) & 7;	//Which row?
			//	drawPattern((_u8)x, 
			//	            data16 & 0x01FF, 
			//		        (data16 & 0x4000) ? 7 - row : row,
			//		        data16 & 0x8000,
			//		        (_u16*)(ramOff7),
			//		        ram[0x8C00 + spr] & 0xF,
			//		        priority << 1); 
			//}





    }
    //==========
  }
}






















__inline void DrawTileLine(void* _screen, _u16 tile, void* _pal, int mirror )
{
  _u16* screen 	= (_u16*)_screen;
  _u16* pal		= (_u16*)_pal;
  // For transparent pixels -> Blur the two bits per pixel to enhance check
  int	tilesolid = tile|(tile>>1);

	  // Forward / Positive
	  if (!mirror)
	  {
		if ( tilesolid&0x4000 )
			screen[0] = pal[(tile>>14)&3];
		if ( tilesolid&0x1000 )
			screen[1] = pal[(tile>>12)&3];
		if ( tilesolid&0x0400 )
			screen[2] = pal[(tile>>10)&3];
		if ( tilesolid&0x0100 )
			screen[3] = pal[(tile>>8)&3];
		if ( tilesolid&0x0040 )
			screen[4] = pal[(tile>>6)&3];
		if ( tilesolid&0x0010 )
			screen[5] = pal[(tile>>4)&3];
		if ( tilesolid&0x0004 )
			screen[6] = pal[(tile>>2)&3];
		if ( tilesolid&0x0001 )
			screen[7] = pal[(tile>>0)&3];
	  }
	  else //Backward / Positive
	  {
		if ( tilesolid&0x4000 )
			screen[7-0] = pal[(tile>>14)&3];
		if ( tilesolid&0x1000 )
			screen[7-1] = pal[(tile>>12)&3];
		if ( tilesolid&0x0400 )
			screen[7-2] = pal[(tile>>10)&3];
		if ( tilesolid&0x0100 )
			screen[7-3] = pal[(tile>>8)&3];
		if ( tilesolid&0x0040 )
			screen[7-4] = pal[(tile>>6)&3];
		if ( tilesolid&0x0010 )
			screen[7-5] = pal[(tile>>4)&3];
		if ( tilesolid&0x0004 )
			screen[7-6] = pal[(tile>>2)&3];
		if ( tilesolid&0x0001 )
			screen[7-7] = pal[(tile>>0)&3];
	  }
}



void NextDrawTileLine(_u16* screenrow, _u8 posx, _u16 tile, void* _pal, int mirror )
{
	int		cmask;
	int		tilemask;
	int		ctile;
	int		dec;
	_u16*	screen;
	_u16*	pal		= (_u16*)_pal;

	// if tile must be X-mirrored
	if ( mirror )
	{
		//Trick : X-mirror the bitmap bits		
		tile = tile>>8|tile<<8;
		tile = (tile&0xF0F0)>>4|((tile<<4)&0xF0F0);
		tile = (tile&0xCCCC)>>2|((tile<<2)&0xCCCC);
	}
	
	// tilemask builded
	tilemask 	= tile|tile>>1;

	//	Transforme	en masque 8bits
	tilemask	&= 	0x5555;
	tilemask	|=  tilemask>>1;
	tilemask	&=	0x3333;
	tilemask	|=  tilemask>>2;
	tilemask	&=	0x0F0F;
	tilemask	|=	tilemask>>4;
	
	// Build Part One mask
	cmask		= 0xFF<<(0&7);
	cmask		&= tilemask;
	cmask		&= linemask[posx>>3];
	
	// Quelque chose  afficher dans le premier quadrant
	if ( cmask )
	{
		// A faire : Aller chercher la palette  ce moment la
		
		linemask[posx>>3] &= ~cmask;
		screen = screenrow+(posx>>3);
		cmask<<=24;
		ctile=tile;
		
		while ( cmask )
		{
			if ( cmask&0x40000000 )
				*screen = pal[(ctile>>30)];
			screen++;
			cmask<<=1;
			ctile<<=2;
		}
	}
	
	// Positionnement sur cran
	posx++;
	posx&=0xFF;
	
	dec			= 16-((0&7)<<1);

	// Build part Two mask
	tilemask	<<= dec;
	tilemask	&= linemask[posx>>3];
	
	if ( tilemask )
	{
		linemask[posx>>3] &= ~tilemask;
		screen = screenrow+(posx>>3);
		tilemask<<=32;
		tile	<<= dec;	
		while ( cmask )
		{
			if ( cmask&0x40000000 )
				*screen = pal[ctile>>30];
			screen++;
			cmask<<=2;
			ctile<<=2;
		}
	}
}




