
	.align 4
	.globl  ljp_asmfastrenderX15
	.globl  ljp_asmfastrenderX15sm
	.globl  ljp_asmfastrender
	.globl  ljp_asmfastrender256
	.globl  ljp_asmfastrender320
	.globl  ljp_asmfastrenderX15sm256
	.globl  ljp_asmfastrenderX15256
	.globl  ljp_asmfastrenderX15_224
	.globl  ljp_asmfastrenderX15sm_224
	
ljp_asmfastrender:
		cmp   r2,#0
		beq	  finN
		stmfd r13!,{r3-r12,r14}	
		mov	  r14,r3
		bic		r0,r0,#3
		bic		r1,r1,#3
	 loopYN:	
		ldmia r1!,{r3-r12}  //r3-r12 : 10regs -> 40bytes <=> 20pixels
		stmia r0!,{r3-r12} //20
		ldmia r1!,{r3-r12}
		stmia r0!,{r3-r12} //40
		ldmia r1!,{r3-r12}
		stmia r0!,{r3-r12} //60
		ldmia r1!,{r3-r12}
		stmia r0!,{r3-r12} //80
		ldmia r1!,{r3-r12}
		stmia r0!,{r3-r12} //100
		ldmia r1!,{r3-r12}
		stmia r0!,{r3-r12} //120
		ldmia r1!,{r3-r12}
		stmia r0!,{r3-r12} //140
		ldmia r1!,{r3-r12}
		stmia r0!,{r3-r12} //160
		ldmia r1!,{r3-r12}
		stmia r0!,{r3-r12} //180
		ldmia r1!,{r3-r12}
		stmia r0!,{r3-r12} //200
		ldmia r1!,{r3-r12}
		stmia r0!,{r3-r12} //220
		ldmia r1!,{r3-r12}
		stmia r0!,{r3-r12} //240
		ldmia r1!,{r3-r10}
		stmia r0!,{r3-r10} //256						
		add	  r0,r0,r14 
		subs  r2,r2,#1
		bne   loopYN
	
		
		ldmfd r13!,{r3-r12,r14}	
	finN:	
		mov   pc,lr

ljp_asmfastrender256:
		cmp   r2,#0
		beq	  fin256N
		stmfd r13!,{r3-r12,r14}	
		mov	  r14,r3
		bic		r0,r0,#3
		bic		r1,r1,#3
	 loopY256N:	
		ldmia r1!,{r3-r12}  //r3-r12 : 10regs -> 40bytes <=> 20pixels
		stmia r0!,{r3-r12} //20
		ldmia r1!,{r3-r12}
		stmia r0!,{r3-r12} //40
		ldmia r1!,{r3-r12}
		stmia r0!,{r3-r12} //60
		ldmia r1!,{r3-r12}
		stmia r0!,{r3-r12} //80
		ldmia r1!,{r3-r12}
		stmia r0!,{r3-r12} //100
		ldmia r1!,{r3-r12}
		stmia r0!,{r3-r12} //120
		ldmia r1!,{r3-r12}
		stmia r0!,{r3-r12} //140
		ldmia r1!,{r3-r12}
		stmia r0!,{r3-r12} //160
		ldmia r1!,{r3-r12}
		stmia r0!,{r3-r12} //180
		ldmia r1!,{r3-r12}
		stmia r0!,{r3-r12} //200
		ldmia r1!,{r3-r12}
		stmia r0!,{r3-r12} //220
		ldmia r1!,{r3-r12}
		stmia r0!,{r3-r12} //240
		ldmia r1!,{r3-r10}
		stmia r0!,{r3-r10} //256						
		add	  r1,r1,#512	 //512-256 << 1
		add	  r0,r0,r14 
		subs  r2,r2,#1
		bne   loopY256N			
		ldmfd r13!,{r3-r12,r14}	
	fin256N:	
		mov   pc,lr
		
ljp_asmfastrender320:
		cmp   r2,#0
		beq	  fin320N
		stmfd r13!,{r3-r12,r14}	
		mov	  r14,r3
		bic		r0,r0,#3
		bic		r1,r1,#3
	 loopY320N:	
		ldmia r1!,{r3-r12}  //r3-r12 : 10regs -> 40bytes <=> 20pixels
		stmia r0!,{r3-r12} //20
		ldmia r1!,{r3-r12}
		stmia r0!,{r3-r12} //40
		ldmia r1!,{r3-r12}
		stmia r0!,{r3-r12} //60
		ldmia r1!,{r3-r12}
		stmia r0!,{r3-r12} //80
		ldmia r1!,{r3-r12}
		stmia r0!,{r3-r12} //100
		ldmia r1!,{r3-r12}
		stmia r0!,{r3-r12} //120
		ldmia r1!,{r3-r12}
		stmia r0!,{r3-r12} //140
		ldmia r1!,{r3-r12}
		stmia r0!,{r3-r12} //160
		ldmia r1!,{r3-r12}
		stmia r0!,{r3-r12} //180
		ldmia r1!,{r3-r12}
		stmia r0!,{r3-r12} //200
		ldmia r1!,{r3-r12}
		stmia r0!,{r3-r12} //220
		ldmia r1!,{r3-r12}
		stmia r0!,{r3-r12} //240
		ldmia r1!,{r3-r12}
		stmia r0!,{r3-r12} //260
		ldmia r1!,{r3-r12}
		stmia r0!,{r3-r12} //280
		ldmia r1!,{r3-r12}
		stmia r0!,{r3-r12} //300
		ldmia r1!,{r3-r12}
		stmia r0!,{r3-r12} //320
		add	  r1,r1,#384	 //512-320 << 1
		add	  r0,r0,r14 
		subs  r2,r2,#1
		bne   loopY320N
	
		
		ldmfd r13!,{r3-r12,r14}	
	fin320N:	
		mov   pc,lr		

	
ljp_asmfastrenderX15:		

#define _asmcopy16pix()\
	  ldmia  r11!,{r3-r10}; \
	  stmia  r0!,{r3-r10};
	  
#define _asmwrite10pix()\
		ldmia  r1!,{r3-r6};\
		mov	   r12,r4,lsr #16;\
		stmia  r0!,{r3,r4};\
		strh   r12,[r0],#2;\
		mov	   r12,r5,lsr #16;\
		mov	   r7,r6,lsr #16;\
		strh   r5,[r0],#2;\
		orr		 r7,r7,r7,lsl #16;\
		strh   r12,[r0],#2;\
		strh   r6,[r0],#2;\
		str    r7,[r0],#4
	
		cmp   r2,#0
		beq	  fin
		stmfd r13!,{r3-r12,r14}	
		mov	  r14,r3
		mov	  r2,r2,lsr #2
		bic		r0,r0,#3
		bic		r1,r1,#3
	 loopY:	
	  
	  
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		add	  r0,r0,r14
		
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		add	  r0,r0,r14
		
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		add	  r0,r0,r14
		
		mov	  r11,r0
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		add	  r0,r0,r14
		
		
		_asmcopy16pix()
		_asmcopy16pix()
		_asmcopy16pix()
		_asmcopy16pix()
		_asmcopy16pix()
		_asmcopy16pix()
		_asmcopy16pix()
		_asmcopy16pix()
		_asmcopy16pix()
		_asmcopy16pix()
		_asmcopy16pix()
		_asmcopy16pix()
		_asmcopy16pix()
		_asmcopy16pix()
		_asmcopy16pix()
		_asmcopy16pix()
		_asmcopy16pix()
		_asmcopy16pix()
		_asmcopy16pix()
		_asmcopy16pix()
		add	  r0,r0,r14
				
#undef _asmwrite10pix
#undef _asmcopy16pix
				 
		subs  r2,r2,#1
		bne   loopY
	
		ldmfd r13!,{r3-r12,r14}	
fin:				
		mov   pc,lr
		


ljp_asmfastrenderX15sm:		

#define _asmwrite10pix()\
		ldmia  r1!,{r3-r6};\
		mov	   r10,r4,lsr #16;\
		stmia  r0!,{r3,r4};\
		and	   r7,r5,#0x1F;\
		and	   r8,r5,#0x7E0;\
		and	   r9,r5,#0xF800;\
		and	   r12,r10,#0x1F;\
		and		 r3,r10,#0x7E0;\
		and		 r10,r10,#0xF800;\
		add	   r7,r7,r12;\
		add	   r8,r8,r3;\
		add	   r9,r9,r10;\
		mov		 r10,r7,lsr #1;\
		mov		 r8,r8,lsr #6;\
		mov		 r9,r9,lsr #12;\
		orr		 r10,r10,r8,lsl #5; \
		orr		 r10,r10,r9,lsl #11; \
		strh   r10,[r0],#2;\
		mov	   r10,r5,lsr #16;\
		strh   r5,[r0],#2;\
		strh   r10,[r0],#2;\
		mov	   r10,r6,lsr #16;\
		strh   r6,[r0],#2;\
		strh   r10,[r0],#2;\
		ldrh	 r3,[r1];\
		and	   r7,r3,#0x1F;\
		and	   r8,r3,#0x7E0;\
		and	   r9,r3,#0xF800;\
		and	   r12,r10,#0x1F;\
		and		 r3,r10,#0x7E0;\
		and		 r10,r10,#0xF800;\
		add	   r7,r7,r12;\
		add	   r8,r8,r3;\
		add	   r9,r9,r10;\
		mov		 r10,r7,lsr #1;\
		mov		 r8,r8,lsr #6;\
		mov		 r9,r9,lsr #12;\
		orr		 r10,r10,r8,lsl #5; \
		orr		 r10,r10,r9,lsl #11; \
		strh   r10,[r0],#2;


#define _asmwrite2pix()\
	  ldr	   r3,[r0],#4; \
	  ldr	   r4,[r11],#4; \
		and	   r5,r3,#0x001F; \
		and	   r6,r3,#0x07E0; \
		and	   r7,r3,#0xF800; \
		and	   r8,r4,#0x001F; \
		and	   r9,r4,#0x07E0; \
		and	   r10,r4,#0xF800; \
		add		 r5,r5,r8; \
		add		 r6,r6,r9; \
		add		 r7,r7,r10; \
		mov		 r5,r5,lsr #1; \
		mov		 r6,r6,lsr #6; \
		mov		 r7,r7,lsr #12; \
		orr		 r5,r5,r6,lsl #5; \
		orr		 r5,r5,r7,lsl #11; \
		and	   r6,r3,#0x001F0000; \
		and	   r7,r3,#0x07E00000; \
		and	   r3,r3,#0xF8000000; \
		and	   r8,r4,#0x001F0000; \
		and	   r9,r4,#0x07E00000; \
		and	   r4,r4,#0xF8000000; \
		add		 r6,r6,r8; \
		add		 r7,r7,r9; \
		adds	 r3,r3,r4; \
		mov		 r6,r6,lsr #17; \
		mov		 r7,r7,lsr #22; \
		mov		 r3,r3,lsr #28; \
		orr		 r5,r5,r6,lsl #16; \
		orrcs	 r3,r3,#0x10; \
		orr		 r5,r5,r7,lsl #21; \
		orr		 r5,r5,r3,lsl #27; \
		str	   r5,[r2],#4;
		
		
		
	
		cmp   r2,#0
		beq	  finsm
		stmfd r13!,{r3-r12,r14}	
		mov	  r14,r3
		mov	  r2,r2,lsr #2	
		bic		r0,r0,#3
		bic		r1,r1,#3
	 
	  
	  mov	  r11,r1
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		add	  r0,r0,r14
		
		mov	  r1,r11
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		add	  r0,r0,r14
		
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		add	  r0,r0,r14
		
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		add	  r0,r0,r14
										
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		add	  r0,r0,r14						
		subs  r2,r2,#1		
		bne		loopYsm	
		ldmfd r13!,{r3-r12,r14}	
		b		  finsm		
loopYsm:			
	  		
		add	  r0,r0,#640
		add	  r0,r0,r14
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		add	  r0,r0,r14
		
		stmfd r13!,{r0,r2}
		sub   r2,r0,#1280
		sub   r2,r2,r14,lsl #1
		sub		r11,r0,#1920
		sub		r11,r11,r14,lsl #1
		sub		r11,r11,r14
		sub   r0,r0,#640
		sub   r0,r0,r14
		_asmwrite2pix()
		_asmwrite2pix()
		_asmwrite2pix()
		_asmwrite2pix()
		_asmwrite2pix()
		_asmwrite2pix()
		_asmwrite2pix()
		_asmwrite2pix()
		_asmwrite2pix()
		_asmwrite2pix()
		_asmwrite2pix()
		_asmwrite2pix()
		_asmwrite2pix()
		_asmwrite2pix()
		_asmwrite2pix()
		_asmwrite2pix()
		_asmwrite2pix()
		_asmwrite2pix()
		_asmwrite2pix()
		_asmwrite2pix()
		_asmwrite2pix()
		_asmwrite2pix()
		_asmwrite2pix()
		_asmwrite2pix()
		_asmwrite2pix()
		_asmwrite2pix()
		_asmwrite2pix()
		_asmwrite2pix()
		_asmwrite2pix()
		_asmwrite2pix()
		_asmwrite2pix()
		_asmwrite2pix()
		_asmwrite2pix()
		_asmwrite2pix()
		_asmwrite2pix()
		_asmwrite2pix()
		_asmwrite2pix()
		_asmwrite2pix()
		_asmwrite2pix()
		_asmwrite2pix()
		_asmwrite2pix()
		_asmwrite2pix()
		_asmwrite2pix()
		_asmwrite2pix()
		_asmwrite2pix()
		_asmwrite2pix()
		_asmwrite2pix()
		_asmwrite2pix()
		_asmwrite2pix()
		_asmwrite2pix()
		_asmwrite2pix()
		_asmwrite2pix()
		_asmwrite2pix()
		_asmwrite2pix()
		_asmwrite2pix()
		_asmwrite2pix()
		_asmwrite2pix()
		_asmwrite2pix()
		_asmwrite2pix()
		_asmwrite2pix()
		_asmwrite2pix()
		_asmwrite2pix()
		_asmwrite2pix()
		_asmwrite2pix()
		_asmwrite2pix()
		_asmwrite2pix()
		_asmwrite2pix()
		_asmwrite2pix()
		_asmwrite2pix()
		_asmwrite2pix()
		_asmwrite2pix()
		_asmwrite2pix()
		_asmwrite2pix()
		_asmwrite2pix()
		_asmwrite2pix()
		_asmwrite2pix()
		_asmwrite2pix()
		_asmwrite2pix()
		_asmwrite2pix()
		_asmwrite2pix()
		_asmwrite2pix()
		_asmwrite2pix()
		_asmwrite2pix()
		_asmwrite2pix()
		_asmwrite2pix()
		_asmwrite2pix()
		_asmwrite2pix()
		_asmwrite2pix()
		_asmwrite2pix()
		_asmwrite2pix()
		_asmwrite2pix()
		_asmwrite2pix()
		_asmwrite2pix()
		_asmwrite2pix()
		_asmwrite2pix()
		_asmwrite2pix()
		_asmwrite2pix()
		_asmwrite2pix()
		_asmwrite2pix()
		_asmwrite2pix()
		_asmwrite2pix()
		_asmwrite2pix()
		_asmwrite2pix()
		_asmwrite2pix()
		_asmwrite2pix()
		_asmwrite2pix()
		_asmwrite2pix()
		_asmwrite2pix()
		_asmwrite2pix()
		_asmwrite2pix()
		_asmwrite2pix()
		_asmwrite2pix()
		_asmwrite2pix()
		_asmwrite2pix()
		_asmwrite2pix()
		_asmwrite2pix()
		_asmwrite2pix()
		_asmwrite2pix()
		_asmwrite2pix()
		_asmwrite2pix()
		_asmwrite2pix()
		_asmwrite2pix()
		_asmwrite2pix()
		_asmwrite2pix()
		_asmwrite2pix()
		_asmwrite2pix()
		_asmwrite2pix()
		_asmwrite2pix()
		_asmwrite2pix()
		_asmwrite2pix()
		_asmwrite2pix()
		_asmwrite2pix()
		_asmwrite2pix()
		_asmwrite2pix()
		_asmwrite2pix()
		_asmwrite2pix()
		_asmwrite2pix()
		_asmwrite2pix()
		_asmwrite2pix()
		_asmwrite2pix()
		_asmwrite2pix()
		_asmwrite2pix()
		_asmwrite2pix()
		_asmwrite2pix()
		_asmwrite2pix()
		_asmwrite2pix()
		_asmwrite2pix()
		_asmwrite2pix()
		_asmwrite2pix()
		_asmwrite2pix()
		_asmwrite2pix()
		_asmwrite2pix()
		_asmwrite2pix()
		_asmwrite2pix()
		_asmwrite2pix()
		_asmwrite2pix()
		_asmwrite2pix()
		_asmwrite2pix()
		_asmwrite2pix()
		_asmwrite2pix()
		ldmfd	r13!,{r0,r2}
		
		
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		add	  r0,r0,r14
		
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		add	  r0,r0,r14
								
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		add	  r0,r0,r14								
#undef _asmwrite10pix
#undef _asmwrite2pix
				 
		subs  r2,r2,#1
		bne   loopYsm
	
		ldmfd r13!,{r3-r12,r14}	
finsm:				
		mov   pc,lr
		

ljp_asmfastrenderX15sm256:

#define _asmwrite10pix()\
		ldmia  r1!,{r3-r6};\
		mov	   r10,r4,lsr #16;\
		stmia  r0!,{r3,r4};\
		and	   r7,r5,#0x1F;\
		and	   r8,r5,#0x7E0;\
		and	   r9,r5,#0xF800;\
		and	   r12,r10,#0x1F;\
		and		 r3,r10,#0x7E0;\
		and		 r10,r10,#0xF800;\
		add	   r7,r7,r12;\
		add	   r8,r8,r3;\
		add	   r9,r9,r10;\
		mov		 r10,r7,lsr #1;\
		mov		 r8,r8,lsr #6;\
		mov		 r9,r9,lsr #12;\
		orr		 r10,r10,r8,lsl #5; \
		orr		 r10,r10,r9,lsl #11; \
		strh   r10,[r0],#2;\
		mov	   r10,r5,lsr #16;\
		strh   r5,[r0],#2;\
		strh   r10,[r0],#2;\
		mov	   r10,r6,lsr #16;\
		strh   r6,[r0],#2;\
		strh   r10,[r0],#2;\
		ldrh	 r3,[r1];\
		and	   r7,r3,#0x1F;\
		and	   r8,r3,#0x7E0;\
		and	   r9,r3,#0xF800;\
		and	   r12,r10,#0x1F;\
		and		 r3,r10,#0x7E0;\
		and		 r10,r10,#0xF800;\
		add	   r7,r7,r12;\
		add	   r8,r8,r3;\
		add	   r9,r9,r10;\
		mov		 r10,r7,lsr #1;\
		mov		 r8,r8,lsr #6;\
		mov		 r9,r9,lsr #12;\
		orr		 r10,r10,r8,lsl #5; \
		orr		 r10,r10,r9,lsl #11; \
		strh   r10,[r0],#2;


#define _asmwrite2pix()\
	  ldr	   r3,[r0],#4; \
	  ldr	   r4,[r11],#4; \
		and	   r5,r3,#0x001F; \
		and	   r6,r3,#0x07E0; \
		and	   r7,r3,#0xF800; \
		and	   r8,r4,#0x001F; \
		and	   r9,r4,#0x07E0; \
		and	   r10,r4,#0xF800; \
		add		 r5,r5,r8; \
		add		 r6,r6,r9; \
		add		 r7,r7,r10; \
		mov		 r5,r5,lsr #1; \
		mov		 r6,r6,lsr #6; \
		mov		 r7,r7,lsr #12; \
		orr		 r5,r5,r6,lsl #5; \
		orr		 r5,r5,r7,lsl #11; \
		and	   r6,r3,#0x001F0000; \
		and	   r7,r3,#0x07E00000; \
		and	   r3,r3,#0xF8000000; \
		and	   r8,r4,#0x001F0000; \
		and	   r9,r4,#0x07E00000; \
		and	   r4,r4,#0xF8000000; \
		add		 r6,r6,r8; \
		add		 r7,r7,r9; \
		adds	 r3,r3,r4; \
		mov		 r6,r6,lsr #17; \
		mov		 r7,r7,lsr #22; \
		mov		 r3,r3,lsr #28; \
		orr		 r5,r5,r6,lsl #16; \
		orrcs	 r3,r3,#0x10; \
		orr		 r5,r5,r7,lsl #21; \
		orr		 r5,r5,r3,lsl #27; \
		str	   r5,[r2],#4;
		
		
		
	
		cmp   r2,#0
		beq	  finsm256
		stmfd r13!,{r3-r12,r14}	
		mov	  r14,r3
		mov	  r2,r2,lsr #2	
		bic		r0,r0,#3
		bic		r1,r1,#3
	 
	  
	  mov	  r11,r1
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		add	  r0,r0,r14		
		
		mov	  r1,r11
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		add	  r0,r0,r14
		add		r1,r1,#512
		
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		add	  r0,r0,r14
		add		r1,r1,#512
		
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		add	  r0,r0,r14
		add		r1,r1,#512
										
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		add	  r0,r0,r14						
		add		r1,r1,#512
		subs  r2,r2,#1		
		bne		loopYsm256
		ldmfd r13!,{r3-r12,r14}	
		b		  finsm256
loopYsm256:			
	  		
		add	  r0,r0,#640
		add	  r0,r0,r14
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		add	  r0,r0,r14
		add		r1,r1,#512
		
		stmfd r13!,{r0,r2}
		sub   r2,r0,#1280
		sub   r2,r2,r14,lsl #1
		sub		r11,r0,#1920
		sub		r11,r11,r14,lsl #1
		sub		r11,r11,r14
		sub   r0,r0,#640
		sub   r0,r0,r14
		_asmwrite2pix()
		_asmwrite2pix()
		_asmwrite2pix()
		_asmwrite2pix()
		_asmwrite2pix()
		_asmwrite2pix()
		_asmwrite2pix()
		_asmwrite2pix()
		_asmwrite2pix()
		_asmwrite2pix()
		_asmwrite2pix()
		_asmwrite2pix()
		_asmwrite2pix()
		_asmwrite2pix()
		_asmwrite2pix()
		_asmwrite2pix()
		_asmwrite2pix()
		_asmwrite2pix()
		_asmwrite2pix()
		_asmwrite2pix()
		_asmwrite2pix()
		_asmwrite2pix()
		_asmwrite2pix()
		_asmwrite2pix()
		_asmwrite2pix()
		_asmwrite2pix()
		_asmwrite2pix()
		_asmwrite2pix()
		_asmwrite2pix()
		_asmwrite2pix()
		_asmwrite2pix()
		_asmwrite2pix()
		_asmwrite2pix()
		_asmwrite2pix()
		_asmwrite2pix()
		_asmwrite2pix()
		_asmwrite2pix()
		_asmwrite2pix()
		_asmwrite2pix()
		_asmwrite2pix()
		_asmwrite2pix()
		_asmwrite2pix()
		_asmwrite2pix()
		_asmwrite2pix()
		_asmwrite2pix()
		_asmwrite2pix()
		_asmwrite2pix()
		_asmwrite2pix()
		_asmwrite2pix()
		_asmwrite2pix()
		_asmwrite2pix()
		_asmwrite2pix()
		_asmwrite2pix()
		_asmwrite2pix()
		_asmwrite2pix()
		_asmwrite2pix()
		_asmwrite2pix()
		_asmwrite2pix()
		_asmwrite2pix()
		_asmwrite2pix()
		_asmwrite2pix()
		_asmwrite2pix()
		_asmwrite2pix()
		_asmwrite2pix()
		_asmwrite2pix()
		_asmwrite2pix()
		_asmwrite2pix()
		_asmwrite2pix()
		_asmwrite2pix()
		_asmwrite2pix()
		_asmwrite2pix()
		_asmwrite2pix()
		_asmwrite2pix()
		_asmwrite2pix()
		_asmwrite2pix()
		_asmwrite2pix()
		_asmwrite2pix()
		_asmwrite2pix()
		_asmwrite2pix()
		_asmwrite2pix()
		_asmwrite2pix()
		_asmwrite2pix()
		_asmwrite2pix()
		_asmwrite2pix()
		_asmwrite2pix()
		_asmwrite2pix()
		_asmwrite2pix()
		_asmwrite2pix()
		_asmwrite2pix()
		_asmwrite2pix()
		_asmwrite2pix()
		_asmwrite2pix()
		_asmwrite2pix()
		_asmwrite2pix()
		_asmwrite2pix()
		_asmwrite2pix()
		_asmwrite2pix()
		_asmwrite2pix()
		_asmwrite2pix()
		_asmwrite2pix()
		_asmwrite2pix()
		_asmwrite2pix()
		_asmwrite2pix()
		_asmwrite2pix()
		_asmwrite2pix()
		_asmwrite2pix()
		_asmwrite2pix()
		_asmwrite2pix()
		_asmwrite2pix()
		_asmwrite2pix()
		_asmwrite2pix()
		_asmwrite2pix()
		_asmwrite2pix()
		_asmwrite2pix()
		_asmwrite2pix()
		_asmwrite2pix()
		_asmwrite2pix()
		_asmwrite2pix()
		_asmwrite2pix()
		_asmwrite2pix()
		_asmwrite2pix()
		_asmwrite2pix()
		_asmwrite2pix()
		_asmwrite2pix()
		_asmwrite2pix()
		_asmwrite2pix()
		_asmwrite2pix()
		_asmwrite2pix()
		_asmwrite2pix()
		_asmwrite2pix()
		_asmwrite2pix()
		_asmwrite2pix()
		_asmwrite2pix()
		_asmwrite2pix()
		_asmwrite2pix()
		_asmwrite2pix()
		_asmwrite2pix()
		_asmwrite2pix()
		_asmwrite2pix()
		_asmwrite2pix()
		_asmwrite2pix()
		_asmwrite2pix()
		_asmwrite2pix()
		_asmwrite2pix()
		_asmwrite2pix()
		_asmwrite2pix()
		_asmwrite2pix()
		_asmwrite2pix()
		_asmwrite2pix()
		_asmwrite2pix()
		_asmwrite2pix()
		_asmwrite2pix()
		_asmwrite2pix()
		_asmwrite2pix()
		_asmwrite2pix()
		_asmwrite2pix()
		_asmwrite2pix()
		_asmwrite2pix()
		_asmwrite2pix()
		_asmwrite2pix()
		ldmfd	r13!,{r0,r2}
		
		
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		add	  r0,r0,r14
		add		r1,r1,#512
		
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		add	  r0,r0,r14
		add		r1,r1,#512
								
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		add	  r0,r0,r14	
		add		r1,r1,#512							
#undef _asmwrite10pix
#undef _asmwrite2pix
				 
		subs  r2,r2,#1
		bne   loopYsm256
	
		ldmfd r13!,{r3-r12,r14}	
finsm256:				
		mov   pc,lr
		


ljp_asmfastrenderX15256:		

#define _asmcopy16pix()\
	  ldmia  r11!,{r3-r10}; \
	  stmia  r0!,{r3-r10};
	  
#define _asmwrite10pix()\
		ldmia  r1!,{r3-r6};\
		mov	   r12,r4,lsr #16;\
		stmia  r0!,{r3,r4};\
		strh   r12,[r0],#2;\
		mov	   r12,r5,lsr #16;\
		mov	   r7,r6,lsr #16;\
		strh   r5,[r0],#2;\
		orr		 r7,r7,r7,lsl #16;\
		strh   r12,[r0],#2;\
		strh   r6,[r0],#2;\
		str    r7,[r0],#4
	
		cmp   r2,#0
		beq	  fin256
		stmfd r13!,{r3-r12,r14}	
		mov	  r14,r3
		mov	  r2,r2,lsr #2
		bic		r0,r0,#3
		bic		r1,r1,#3
	 loopY256:	
	  
	  
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		add	  r0,r0,r14
		add	  r1,r1,#512
		
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		add	  r0,r0,r14
		add	  r1,r1,#512
		
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		add	  r0,r0,r14
		add	  r1,r1,#512
		
		mov	  r11,r0
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		add	  r0,r0,r14
		add	  r1,r1,#512
		
		_asmcopy16pix()
		_asmcopy16pix()
		_asmcopy16pix()
		_asmcopy16pix()
		_asmcopy16pix()
		_asmcopy16pix()
		_asmcopy16pix()
		_asmcopy16pix()
		_asmcopy16pix()
		_asmcopy16pix()
		_asmcopy16pix()
		_asmcopy16pix()
		_asmcopy16pix()
		_asmcopy16pix()
		_asmcopy16pix()
		_asmcopy16pix()
		_asmcopy16pix()
		_asmcopy16pix()
		_asmcopy16pix()
		_asmcopy16pix()
		add	  r0,r0,r14		
#undef _asmwrite10pix
#undef _asmcopy16pix
	  				 
		subs  r2,r2,#1
		bne   loopY256
	
		ldmfd r13!,{r3-r12,r14}	
fin256:				
		mov   pc,lr




ljp_asmfastrenderX15_224:

#define _asmcopy16pix()\
	  ldmia  r11!,{r3-r10}; \
	  stmia  r0!,{r3-r10};
	  
#define _asmwrite10pix()\
		ldmia  r1!,{r3-r6};\
		mov	   r12,r4,lsr #16;\
		stmia  r0!,{r3,r4};\
		strh   r12,[r0],#2;\
		mov	   r12,r5,lsr #16;\
		mov	   r7,r6,lsr #16;\
		strh   r5,[r0],#2;\
		orr		 r7,r7,r7,lsl #16;\
		strh   r12,[r0],#2;\
		strh   r6,[r0],#2;\
		str    r7,[r0],#4
	
		cmp   r2,#0
		beq	  fin_224
		stmfd r13!,{r3-r12,r14}	
		mov	  r14,r3
		mov	  r2,r2,lsr #2
		bic		r0,r0,#3
		bic		r1,r1,#3
	 loopY_224:	
	  
	  
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()		
		add	  r0,r0,r14
		
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()		
		add	  r0,r0,r14
		
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()		
		add	  r0,r0,r14
		
		mov	  r11,r0
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		add	  r0,r0,r14
		
		
		_asmcopy16pix()
		_asmcopy16pix()
		_asmcopy16pix()
		_asmcopy16pix()
		_asmcopy16pix()
		_asmcopy16pix()
		_asmcopy16pix()
		_asmcopy16pix()
		_asmcopy16pix()
		_asmcopy16pix()
		_asmcopy16pix()
		_asmcopy16pix()
		_asmcopy16pix()
		_asmcopy16pix()
		_asmcopy16pix()
		_asmcopy16pix()
		_asmcopy16pix()
		ldmia  r11!,{r3-r6};
	  stmia  r0!,{r3-r6};
		add	  r0,r0,r14
				
#undef _asmwrite10pix
#undef _asmcopy16pix
				 
		subs  r2,r2,#1
		bne   loopY_224
	
		ldmfd r13!,{r3-r12,r14}	
fin_224:
		mov   pc,lr
		


ljp_asmfastrenderX15sm_224:

#define _asmwrite10pix()\
		ldmia  r1!,{r3-r6};\
		mov	   r10,r4,lsr #16;\
		stmia  r0!,{r3,r4};\
		and	   r7,r5,#0x1F;\
		and	   r8,r5,#0x7E0;\
		and	   r9,r5,#0xF800;\
		and	   r12,r10,#0x1F;\
		and		 r3,r10,#0x7E0;\
		and		 r10,r10,#0xF800;\
		add	   r7,r7,r12;\
		add	   r8,r8,r3;\
		add	   r9,r9,r10;\
		mov		 r10,r7,lsr #1;\
		mov		 r8,r8,lsr #6;\
		mov		 r9,r9,lsr #12;\
		orr		 r10,r10,r8,lsl #5; \
		orr		 r10,r10,r9,lsl #11; \
		strh   r10,[r0],#2;\
		mov	   r10,r5,lsr #16;\
		strh   r5,[r0],#2;\
		strh   r10,[r0],#2;\
		mov	   r10,r6,lsr #16;\
		strh   r6,[r0],#2;\
		strh   r10,[r0],#2;\
		ldrh	 r3,[r1];\
		and	   r7,r3,#0x1F;\
		and	   r8,r3,#0x7E0;\
		and	   r9,r3,#0xF800;\
		and	   r12,r10,#0x1F;\
		and		 r3,r10,#0x7E0;\
		and		 r10,r10,#0xF800;\
		add	   r7,r7,r12;\
		add	   r8,r8,r3;\
		add	   r9,r9,r10;\
		mov		 r10,r7,lsr #1;\
		mov		 r8,r8,lsr #6;\
		mov		 r9,r9,lsr #12;\
		orr		 r10,r10,r8,lsl #5; \
		orr		 r10,r10,r9,lsl #11; \
		strh   r10,[r0],#2;


#define _asmwrite2pix()\
	  ldr	   r3,[r0],#4; \
	  ldr	   r4,[r11],#4; \
		and	   r5,r3,#0x001F; \
		and	   r6,r3,#0x07E0; \
		and	   r7,r3,#0xF800; \
		and	   r8,r4,#0x001F; \
		and	   r9,r4,#0x07E0; \
		and	   r10,r4,#0xF800; \
		add		 r5,r5,r8; \
		add		 r6,r6,r9; \
		add		 r7,r7,r10; \
		mov		 r5,r5,lsr #1; \
		mov		 r6,r6,lsr #6; \
		mov		 r7,r7,lsr #12; \
		orr		 r5,r5,r6,lsl #5; \
		orr		 r5,r5,r7,lsl #11; \
		and	   r6,r3,#0x001F0000; \
		and	   r7,r3,#0x07E00000; \
		and	   r3,r3,#0xF8000000; \
		and	   r8,r4,#0x001F0000; \
		and	   r9,r4,#0x07E00000; \
		and	   r4,r4,#0xF8000000; \
		add		 r6,r6,r8; \
		add		 r7,r7,r9; \
		adds	 r3,r3,r4; \
		mov		 r6,r6,lsr #17; \
		mov		 r7,r7,lsr #22; \
		mov		 r3,r3,lsr #28; \
		orr		 r5,r5,r6,lsl #16; \
		orrcs	 r3,r3,#0x10; \
		orr		 r5,r5,r7,lsl #21; \
		orr		 r5,r5,r3,lsl #27; \
		str	   r5,[r2],#4;
		
		
		
	
		cmp   r2,#0
		beq	  finsm_224
		stmfd r13!,{r3-r12,r14}	
		mov	  r14,r3
		mov	  r2,r2,lsr #2	
		bic		r0,r0,#3
		bic		r1,r1,#3
	 
	  
	  mov	  r11,r1
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()		
		add	  r0,r0,r14
		
		mov	  r1,r11
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()		
		add	  r0,r0,r14
		
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()		
		add	  r0,r0,r14
		
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()		
		add	  r0,r0,r14
										
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()		
		add	  r0,r0,r14						
		subs  r2,r2,#1		
		bne		loopYsm_224
		ldmfd r13!,{r3-r12,r14}	
		b		  finsm_224
loopYsm_224:
	  		
		add	  r0,r0,#560
		add	  r0,r0,r14
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()		
		add	  r0,r0,r14
		
		stmfd r13!,{r0,r2}
		sub   r2,r0,#1120
		sub   r2,r2,r14,lsl #1
		sub		r11,r0,#1680
		sub		r11,r11,r14,lsl #1
		sub		r11,r11,r14
		sub   r0,r0,#560
		sub   r0,r0,r14
		_asmwrite2pix()
		_asmwrite2pix()
		_asmwrite2pix()
		_asmwrite2pix()
		_asmwrite2pix()
		_asmwrite2pix()
		_asmwrite2pix()
		_asmwrite2pix()
		_asmwrite2pix()
		_asmwrite2pix()
		_asmwrite2pix()
		_asmwrite2pix()
		_asmwrite2pix()
		_asmwrite2pix()
		_asmwrite2pix()
		_asmwrite2pix()
		_asmwrite2pix()
		_asmwrite2pix()
		_asmwrite2pix()
		_asmwrite2pix()
		_asmwrite2pix()
		_asmwrite2pix()
		_asmwrite2pix()
		_asmwrite2pix()
		_asmwrite2pix()
		_asmwrite2pix()
		_asmwrite2pix()
		_asmwrite2pix()
		_asmwrite2pix()
		_asmwrite2pix()
		_asmwrite2pix()
		_asmwrite2pix()
		_asmwrite2pix()
		_asmwrite2pix()
		_asmwrite2pix()
		_asmwrite2pix()
		_asmwrite2pix()
		_asmwrite2pix()
		_asmwrite2pix()
		_asmwrite2pix()
		_asmwrite2pix()
		_asmwrite2pix()
		_asmwrite2pix()
		_asmwrite2pix()
		_asmwrite2pix()
		_asmwrite2pix()
		_asmwrite2pix()
		_asmwrite2pix()
		_asmwrite2pix()
		_asmwrite2pix()
		_asmwrite2pix()
		_asmwrite2pix()
		_asmwrite2pix()
		_asmwrite2pix()
		_asmwrite2pix()
		_asmwrite2pix()
		_asmwrite2pix()
		_asmwrite2pix()
		_asmwrite2pix()
		_asmwrite2pix()
		_asmwrite2pix()
		_asmwrite2pix()
		_asmwrite2pix()
		_asmwrite2pix()
		_asmwrite2pix()
		_asmwrite2pix()
		_asmwrite2pix()
		_asmwrite2pix()
		_asmwrite2pix()
		_asmwrite2pix()
		_asmwrite2pix()
		_asmwrite2pix()
		_asmwrite2pix()
		_asmwrite2pix()
		_asmwrite2pix()
		_asmwrite2pix()
		_asmwrite2pix()
		_asmwrite2pix()
		_asmwrite2pix()
		_asmwrite2pix()
		_asmwrite2pix()
		_asmwrite2pix()
		_asmwrite2pix()
		_asmwrite2pix()
		_asmwrite2pix()
		_asmwrite2pix()
		_asmwrite2pix()
		_asmwrite2pix()
		_asmwrite2pix()
		_asmwrite2pix()
		_asmwrite2pix()
		_asmwrite2pix()
		_asmwrite2pix()
		_asmwrite2pix()
		_asmwrite2pix()
		_asmwrite2pix()
		_asmwrite2pix()
		_asmwrite2pix()
		_asmwrite2pix()
		_asmwrite2pix()
		_asmwrite2pix()
		_asmwrite2pix()
		_asmwrite2pix()
		_asmwrite2pix()
		_asmwrite2pix()
		_asmwrite2pix()
		_asmwrite2pix()
		_asmwrite2pix()
		_asmwrite2pix()
		_asmwrite2pix()
		_asmwrite2pix()
		_asmwrite2pix()
		_asmwrite2pix()
		_asmwrite2pix()
		_asmwrite2pix()
		_asmwrite2pix()
		_asmwrite2pix()
		_asmwrite2pix()
		_asmwrite2pix()
		_asmwrite2pix()
		_asmwrite2pix()
		_asmwrite2pix()
		_asmwrite2pix()
		_asmwrite2pix()
		_asmwrite2pix()
		_asmwrite2pix()
		_asmwrite2pix()
		_asmwrite2pix()
		_asmwrite2pix()
		_asmwrite2pix()
		_asmwrite2pix()
		_asmwrite2pix()
		_asmwrite2pix()
		_asmwrite2pix()
		_asmwrite2pix()
		_asmwrite2pix()
		_asmwrite2pix()
		_asmwrite2pix()
		_asmwrite2pix()
		_asmwrite2pix()		
		ldmfd	r13!,{r0,r2}
		
		
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()		
		add	  r0,r0,r14
		
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()		
		add	  r0,r0,r14
								
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()
		_asmwrite10pix()		
		add	  r0,r0,r14								
#undef _asmwrite10pix
#undef _asmwrite2pix
				 
		subs  r2,r2,#1
		bne   loopYsm_224
	
		ldmfd r13!,{r3-r12,r14}	
finsm_224:
		mov   pc,lr
